//
// allisog.cc -- input a curve, find ALL isogenous curves
//

//#define TEST

#include "isogs.h"
#include "reader.h"

main(){
#ifdef LiDIA
  long lidia_precision=40;
  cout<<"Enter number of decimal places: "; cin>>lidia_precision;
  bigfloat::precision(lidia_precision);
#else
  cout.precision(15);
#endif
  int verbose=0;
  cout << "Verbose? (0/1) " << flush;  cin >> verbose;

  initprimes("PRIMES",verbose);
	
  CurveReader input;
  Curve E;
  Curvedata D;
  CurveRed C;

  while (input>>E)
    {
      D = Curvedata(E);
      C = CurveRed(D);
      IsogenyClass cl(C ,verbose);
      cl.grow();
      cl.display(cout);
#ifdef TEST
      CurveRedArray curves = cl.getcurves();
      cout << "Curve list via getcurves(): " << curves << endl;
      longlist mat = cl.getmat();
      long ncurves = curves.getlength();
      long i,j;
      cout << "Isogeny matrix via getmat():\n";
      cout << "\t"; for(j=0; j<ncurves; j++) cout<<(j+1)<<"\t";  cout<<"\n";
      for(i=0; i<ncurves; i++)
	{
	  cout<<(i+1)<<"\t"; 
	  for(j=0; j<ncurves; j++) 
	    cout<<mat(i*ncurves+j)<<"\t";  
	  cout<<"\n";
	}
      cout<<endl;
#endif
      cout << "Output from dumpdata (rank set arbitrarily to 99):\n\n";
      cl.dumpdata(cout,99);
    }
}
