//MRANK1.H -- definition of class rank1 for
//            computing rank via general 2-descent

class rank1 {
private: 
  Curvedata* the_curve;
  int verbose, traceequiv, certain, success;
  long nquarticsa, nquarticsb, nfirstlota, nfirstlotb;
  long rank, selmer_rank, sha2;
  int posdisc, disc_is_square, npairs, extra2, threediv, type;
  quartic *qlista, *qlistb;
  int * qlistbflag;
  bigcomplex* croots;
  PointArray pointlist1, pointlist2;
  Curvedata IJ_curve;  // [0,0,0,-27*I,-27*J]
  bigint tr_u,tr_r,tr_s,tr_t;  // transformation from latter to minimal curve
  long npoints1, npoints2; int have_eggpoint;
  bigint c4, c6, d1728, ii, jj, disc; 
  bigintArray plist, dlist;
  longlist eqplist;  // primes used for equiv-sieving
  long n0, n1, n2, lim1, lim2;
//
  bigcomplex* cphi;
  bigfloat r,discr,rt,l2,l2dash,p,pdash,q,qdash,rd,re,p2,pdash2,temp;
  bigfloat xii, xjj;
  long Imod2, Jmod2;
  bigfloat aa12,aa6,bb9,a6,aa9;
  long efactor, cfactor;
  long alim,cmin,cmax1,cmax2,cmax,amin,amax;
  long a2,a3,a8,a4,bb,b3,bb3,sb,sb3,ac24;
//
// Sieving stuff:
  int num_aux, ipivot, pivflag;  
  long * auxs; long ** phimod; int * aux_flags; 
  int * aux_rank;  int * aux_selmer;

  int**squares;  
  int ***flags;
  int **flaga;  int *flagah;
  long *amod, *astepmod, *ascalemod, *hmod, *hstepmod, *hscalemod;
  long ah_count, ah_sieve_0, ah_sieve_1, ah_sieve_2;
  long ah_rfail, ah_dfail, ah_efail, ah_extra2fail, ah_pass;
  void aux_init();  // define  auxiliary moduli and squares
  void flag_init(); // set up flag array
  void clear_sieve();  // free memory related to sieve;
//
  void addquartic();  // adds newq if non-triv and inequiv
  void getquartics();
  void getquartics1();
  void gettype(int t);
public:
  rank1(Curvedata* ec, 
        int verb=0, int treq=0, 
        long firstlim=20, long secondlim=5, long n_aux=-1);
// firstlim is bound on |x|+|z|
// secondlim is bound on log max {|x|,|z| }, i.e. logarithmic
// n_aux=-1 causes default to be used (depends on method)
//
  ~rank1() { ; }
  long getrank() const {return rank;}
  long getselmer() const {return selmer_rank;}
  long getcertain()  const {return certain;}
  long getsha()  const {return sha2;}
  int ok()      const {return success;}
  void sortpoints();
  void listpoints(Curvedata* CD_orig=0, const bigint& u=0, const bigint& r=0, 
		                      const bigint& s=0, const bigint& t=0);
  PointArray getgens() const;
  PointArray getpoints() const;
};

// find the number of roots of X^3 + bX^2 + cX + d = 0 (mod p)
// roots are put in r which should be allocated of size 3
int nrootscubic(long b, long c, long d, long p, long* roots);


