// reader.h: class for reading curves from file/tty
//
#include <fstream.h>
#define TTY "/dev/tty"

class CurveReader {
private:
  int prompt;
  char * filename;
  ifstream in;
public:
  CurveReader(char* name = "")
    {prompt=0;
     filename = new char[32];
     if(!strcmp(name,""))
        {cerr << "Enter a filename for curve input (or tty): ";
         cin >> filename;
         if(!strcmp(filename,"tty")) {prompt=1; strcpy(filename,TTY);}
       }
        else
        {
          strcpy(filename,name);
        }
        in.open(filename);
      }
     ~CurveReader() {in.close(); delete filename;}
     int operator>>(Curve& c)
       {
         if(prompt)cerr<<"Enter a curve (null to exit): "<<flush;
         in >> c;
         return !c.isnull();
       }
};
