// REDUCE.H:  Reduction of quartics to smaller coeffs, same I,J

// In both functions, the mij must hold the cumulative transformation on entry, 
// e.g. 1;1,0,0,1 if this is the first step  done
// They will be updated to show the new cumulative transformation

// Full reduction via covariant quadratic:

void reduce(bigint& a, bigint& b, bigint& c, bigint& d, bigint& e,
	    bigint& m00, bigint& m11, bigint& m12, bigint& m21, bigint& m22);

// Simple shift to minimise b:

void reduce_b(bigint& a, bigint& b, bigint& c, bigint& d, bigint& e,
	      bigint& m00, bigint& m11, bigint& m12, bigint& m21, bigint& m22);



