//SQFDIV.H : class for managing square-free divisors

class sqfdiv {
  bigintArray *primebase;  // includes all relevant primes
  bigint d;                // product of current subset
  long np;                  // number in current subset
  int positive;             // flag for sign
  long factor;              // counts log_2 of saving index since initialisation
  bigintArray subgp;       // subgp factored out (complete)
  bigintArray gens;        // generators of latter
  long nsub, maxnsub, ngens, maxngens;       // current, max number in subgp
  longlist pivs;
public:
  sqfdiv(const bigint& dd, int posd, bigintArray* plist);
  void usediv(const bigint& e);  
  bigintArray getdivs() const;
  bigintArray getsupp(int bothsigns=0) const;
  bigintArray getsubgp() {return bigintArray(subgp,nsub);}
  long getfactor() {return factor;}
  void display();
};

bigint sqfred(const bigint& a, const bigintArray& plist);

inline bigint sqfred(const bigint& a)
{ const bigintArray& plist = pdivs(a);
  return sqfred(a,plist);
}

bigint sqfmul(const bigint& a, const bigint& b);

bigint makenum(const bigintArray& supp, long mask);

long makeindex(const bigintArray& supp, const bigint& n, bigint& n0);

// support(n) is like pdivs(n) but includes -1 always (except n=0, 
//but it should never be called with 0)
bigintArray support(const bigint& n);
