//
// torsion.cc -- get torsion points list (PointArray)
//

#include "points.h"
#include "reader.h"


int main(){
  cerr<<"Program to find and/or count torsion on a curve.\n\n";
  cerr<<"Enter 0 for short output (#torsion only)\n";
  cerr<<"   or 1 for long  output (list of the torsion points): ";
  int showpoints; cin >> showpoints;
  initprimes("PRIMES",1);
  CurveReader input;
  Curve F;
  PointArray tor; int ntor, n2;
  bigint u, r, s, t;

  while (input>>F) 
    {
      Curvedata E0 = Curvedata(F,0);
      Curvedata E1 = E0.minimalize(u,r,s,t);
      cout<<"Curve "<<F<<flush;
      tor = torsion_points(E1); 
      ntor = tor.getlength();
      n2=0;
      cout<<" \t has " << ntor << " torsion point(s)\n";
      if(showpoints)
	{
	  for(int i=0; i<ntor; i++)
	    {
	      Point P = shift(tor[i],&E0,u,r,s,t,1);
	      cout << P << "\t";
	      if(!P.isvalid()) cout << " --warning: NOT on curve!\n";
	      else
		{
		  int ord = order(P);
		  if(ord==2) n2++;
		  cout << "(order " << ord << ")\n";
		}
	    }
	  if(n2>2) cout<<"Non-cyclic: C2 x C"<<(ntor/2)<<"\n"; 
	  else cout << "Cyclic: C"<<ntor<<"\n";
	}
    }
} //ends main

	


