// TRANSFORM.H: various routines for transforming quartics
//
// Notation: g(x,z) is replaced by g(m11*x+m12*z,m21*x+m22*z)/m00^2
//


void show_transform(const bigint& m00, const bigint& m11, const bigint& m12, const bigint& m21, const bigint& m22);

void apply_transform(bigint& a, bigint& b, bigint& c, bigint& d, bigint& e,
		     const bigint& m00, const bigint& m11, const bigint& m12, 
		     const bigint& m21, const bigint& m22);

int check_transform(const bigint& a, const bigint& b, const bigint& c, 
		    const bigint& d, const bigint& e,
		    const bigint& m00, const bigint& m11, const bigint& m12, 
		    const bigint& m21, const bigint& m22,
		    const bigint& xa, const bigint& xb, const bigint& xc, 
		    const bigint& xd, const bigint& xe);

void xshift(const bigint& alpha,
	    bigint& a, bigint& b, bigint& c, bigint& d, bigint& e,
	    bigint& m00, bigint& m11, bigint& m12, bigint& m21, bigint& m22);

void zshift(const bigint& gamma,
	    bigint& a, bigint& b, bigint& c, bigint& d, bigint& e,
	    bigint& m00, bigint& m11, bigint& m12, bigint& m21, bigint& m22);

